<template>
  <div class="shopping-section" :class="{'mobile': isMobile()}">
    <div class="background-top" v-if="!isMobile()"></div>
    <div class="main">
      <h2 class="title" v-if="!isMobile()">{{ title }}</h2>
      <div class="wrap-subtitle">
        <h3 class="sub-title">Category</h3>
        <div class="right">
          <span class="prev" :class="categoryArrow.prev?categoryArrow.prev:'hide'"
                @click="triggerClick('categoryPrev')"><a-icon type="left"/></span>
          <span class="next" :class="categoryArrow.next?categoryArrow.next:'hide'"
                @click="triggerClick('categoryNext')"><a-icon type="right"/></span>
        </div>
      </div>
      <carousel :margin="20" :dots="false" :nav="false"
                :responsive="{
                  0:{items:2},576:{items:3},768:{items:4},1200:{items:6},1500:{items:8}
                }"
                @changed="syncArrow('categoryNext', 'categoryPrev', categoryArrow)">
        <template slot="prev"><span class="category-prev" ref="categoryNext">prev</span></template>
        <template slot="next"><span class="category-next" ref="categoryPrev">next</span></template>
        <div class="slide-item" v-for="i in 10" :key="i">
          <router-link :to="`/shopping/category/`+i">
            <div class="wrap-image square">
              <img :src="`img/category` + i + `.jpg`">
            </div>
            <h4 class="title">
              <div class="img">
                <img :src="`icon/category`+i%3+`.png`">
              </div>
              <div class="category-name">Category {{ i }}</div>
            </h4>
          </router-link>
        </div>
      </carousel>
      <div class="wrap-subtitle mt-5 mt-md-5">
        <div>
          <h3 class="sub-title">Running Products</h3>
          <p>Some business items are selling very well today</p>
        </div>
        <div class="right">
          <span class="prev" :class="productArrow.prev?productArrow.prev:'hide'"
                @click="triggerClick('productPrev')"><a-icon type="left"/></span>
          <span class="next" :class="productArrow.next?productArrow.next:'hide'"
                @click="triggerClick('productNext')"><a-icon type="right"/></span>
        </div>
      </div>
      <carousel :margin="20" :dots="false" :nav="false"
                :responsive="{
                  0:{items:2},576:{items:3},768:{items:4},1200:{items:6},1500:{items:8}
                }"
                @changed="syncArrow('productNext', 'productPrev', productArrow)">
        <template slot="prev"><span class="product-prev" ref="productNext">prev</span></template>
        <template slot="next"><span class="product-next" ref="productPrev">next</span></template>
        <div class="product-item" v-for="i in 10" :key="i">
          <router-link :to="{ name: 'ProductDetail', params: {id: i}}">
            <div class="wrap-image square">
              <img :src="`img/category` + i + `.jpg`">
            </div>
          </router-link>
          <router-link :to="{ name: 'ProductDetail', params: {id: i}}">
            <h5 class="title">Product {{ i }}</h5>
          </router-link>
          <p class="price">1.392.000 VND</p>
        </div>
      </carousel>

    </div>
  </div>
</template>

<script>
import carousel from 'vue-owl-carousel'

const items = [
  {
    title: "Shopping",
  }
]

export default {
  components: {carousel},
  data() {
    return {
      title: 'Shopping',
      categoryArrow: {
        prev: true,
        next: true,
      },
      productArrow: {
        prev: true,
        next: true,
      }
    }
  },

  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true
      } else {
        return false
      }
    },
    syncArrow(prev, next, arrowObject) {
      const me = this;
      setTimeout(function () {
        const prevParent = me.$refs[prev] && me.$refs[prev].parentNode;
        const nextParent = me.$refs[next] && me.$refs[next].parentNode;
        if (prevParent) {
          arrowObject.prev = prevParent.style.display !== 'none';
        }
        if (nextParent) {
          arrowObject.next = nextParent.style.display !== 'none';
        }
      }, 200)
    },
    triggerClick(ref) {
      this.$refs[ref].click();
    }
  },
  mounted: function () {
    this.syncArrow('categoryNext', 'categoryPrev', this.categoryArrow);
    this.syncArrow('productNext', 'productPrev', this.productArrow);
  }
}

</script>

<style scoped>
@import "../../css/default.css";

.slide-item {
  position: relative;
}

.slide-item:hover img {
  opacity: 0.7;
}

.wrap-image img {
  opacity: 0.5;
}

.slide-item .img {
  padding: 0 20%;
}

.slide-item .title {
  position: absolute;
  width: 100%;
  height: 100%;
  left: 0;
  top: 0;
  font-size: 20px;
  padding: 10px;
  font-weight: 400;
  display: flex;
  flex-direction: column;
  text-align: center;
  justify-content: center;
}
.slide-item .category-name {
  color: #F1F1F1;
}

.product-item .title {
  font-size: 18px;
  text-transform: uppercase;
  padding: 5px 0;
  font-weight: 400;
  color: #F1F1F1 !important;
}

[class*="-prev"], [class*="-next"]{
  position: absolute;
  z-index: -1;
}

.product-item:hover img {
  opacity: 0.7;
}

.mobile .sub-title {
  font-weight: 500;
  font-size: 18px;
  letter-spacing: -0.24px;
  color: #F1F1F1;
}
.mobile .right {
  min-width: 75px;
}
.mobile .right .next {
  padding-right: 0;
}
.mobile .slide-item .img {
  display: flex;
  align-items: center;
  justify-content: center;
}
.mobile .slide-item .img img {
  width: 50px;
  height: auto;
  margin-bottom: 18px;
}
.mobile .slide-item .category-name {
  font-weight: 500;
  font-size: 14px;
  line-height: 21px;
  color: #FFFFFF;
}
.mobile .product-item .title {
  font-weight: 500;
  font-size: 12px;
  line-height: 18px;
  color: #F1F1F1 !important;
}
.mobile .product-item .price {
  font-weight: 300;
  font-size: 12px;
  line-height: 18px;
  color: #F1F1F1;
}
</style>
